diff --git a/gcc/analyzer/region-model2.cc b/gcc/analyzer/region-model2.cc
index d9c4fffa68c..c7fe5f2e458 100644
--- a/gcc/analyzer/region-model2.cc
+++ b/gcc/analyzer/region-model2.cc
@@ -129,9 +129,9 @@ class impl_constraint_manager : public constraint_manager
     return new impl_constraint_manager (*this, model);
   }
 
-  tree maybe_get_constant (svalue2 *sval) const FINAL OVERRIDE
+  tree maybe_get_constant (const svalue2 *sval) const FINAL OVERRIDE
   {
-    svalue2 *svalue2 = m_model->get_svalue2 (sid);
+    const svalue2 *svalue2 = m_model->get_svalue2 (sid);
     return svalue2->maybe_get_constant ();
   }
 
@@ -350,7 +350,7 @@ region_svalue2::merge_values (const region_svalue2 &region2_sval_a,
      region2s, then the merged ptr has to be "unknown".  */
   if (a_reg_in_m != b_reg_in_m)
     {
-      svalue2 *merged_sval = new unknown_svalue2 (type);
+      const svalue2 *merged_sval = new unknown_svalue2 (type);
       *merged_sval = merger->m_merged_model->add_svalue2 (merged_sval);
       return;
     }
@@ -409,7 +409,7 @@ region_svalue2::merge_values (const region_svalue2 &region2_sval_a,
     }
 
   /* Two different non-NULL pointers?  Merge to unknown.  */
-  svalue2 *merged_sval = new unknown_svalue2 (type);
+  const svalue2 *merged_sval = new unknown_svalue2 (type);
   *merged_sval = merger->m_merged_model->add_svalue2 (merged_sval);
   return;
 }
@@ -420,13 +420,13 @@ region_svalue2::merge_values (const region_svalue2 &region2_sval_a,
    pointers.  */
 
 tristate
-region_svalue2::eval_condition (region_svalue2 *lhs,
+region_svalue2::eval_condition (const region_svalue2 *lhs,
 				enum tree_code op,
-				region_svalue2 *rhs)
+				const region_svalue2 *rhs)
 {
   /* See if they point to the same region2.  */
-  region2 *lhs_reg = lhs->get_pointee ();
-  region2 *rhs_reg = rhs->get_pointee ();
+  const region2 *lhs_reg = lhs->get_pointee ();
+  const region2 *rhs_reg = rhs->get_pointee ();
   bool ptr_equality = lhs_reg == rhs_reg;
   /* TODO: what about child region2s where the child is the first child
      (or descendent)?
@@ -517,7 +517,7 @@ constant_svalue2::merge_values (const constant_svalue2 &cst_sval_a,
 {
   tree cst_a = cst_sval_a.get_constant ();
   tree cst_b = cst_sval_b.get_constant ();
-  svalue2 *merged_sval;
+  const svalue2 *merged_sval;
   if (cst_a == cst_b)
     {
       /* If they are the same constant, merge as that constant value.  */
@@ -540,9 +540,9 @@ constant_svalue2::merge_values (const constant_svalue2 &cst_sval_a,
    constants.  */
 
 tristate
-constant_svalue2::eval_condition (constant_svalue2 *lhs,
-				 enum tree_code op,
-				 constant_svalue2 *rhs)
+constant_svalue2::eval_condition (const constant_svalue2 *lhs,
+				  enum tree_code op,
+				  const constant_svalue2 *rhs)
 {
   tree lhs_const = lhs->get_constant ();
   tree rhs_const = rhs->get_constant ();
@@ -588,7 +588,7 @@ constant_svalue2::get_child_sval (region2 *parent ATTRIBUTE_UNUSED,
      constant.
 
      Handle this case by using an unknown value.  */
-  svalue2 *unknown_sval = new unknown_svalue2 (child->get_type ());
+  const svalue2 *unknown_sval = new unknown_svalue2 (child->get_type ());
   return model.add_svalue2 (unknown_sval);
 }
 #endif
@@ -978,7 +978,7 @@ region2::get_base_region () const
 }
 
 region_offset
-region2::get_offset ()
+region2::get_offset () const
 {
   if(!m_cached_offset)
     m_cached_offset = new region_offset (calc_offset ());
@@ -1085,14 +1085,15 @@ region2::calc_offset () const
 	       pointer svalue.  */
 	    const symbolic_region2 *symbolic_region
 	      = (const symbolic_region2 *)iter_region;
-	    svalue2 *sval = symbolic_region->get_pointer ();
+	    const svalue2 *sval = symbolic_region->get_pointer ();
 	    switch (sval->get_kind ())
 	      {
 	      default:
 		gcc_unreachable ();
 	      case svalue2::SK_BINOP:
 		{
-		  binop_svalue2 *binop_sval = as_a <binop_svalue2 *> (sval);
+		  const binop_svalue2 *binop_sval
+		    = as_a <const binop_svalue2 *> (sval);
 		  switch (binop_sval->get_op ())
 		    {
 		    default:
@@ -1106,8 +1107,8 @@ region2::calc_offset () const
 			   things via element indices, rather than via byte offsets.  */
 			/* Perhaps instead we should capture this as an offset relative
 			   to a base region in region_offset?  */
-			svalue2 *ptr = binop_sval->get_arg0 ();
-			svalue2 *offset = binop_sval->get_arg1 ();
+			const svalue2 *ptr = binop_sval->get_arg0 ();
+			const svalue2 *offset = binop_sval->get_arg1 ();
 			gcc_unreachable ();
 		      }
 		    }
@@ -1136,14 +1137,14 @@ region2::get_representative_path_var () const
    for some kinds of casts).  */
 #if 0
 void
-region2::set_value (region_model2 &model, region2 *lhs_reg, svalue2 *rhs_sval,
+region2::set_value (region_model2 &model, region2 *lhs_reg, const svalue2 *rhs_sval,
 		    region_model2_context *ctxt)
 {
   gcc_unreachable ();
   /* Handle some kinds of casting.  */
   if (m_type)
     {
-      svalue2 *sval = model.get_svalue2 (rhs_sval);
+      const svalue2 *sval = model.get_svalue2 (rhs_sval);
       if (sval->get_type ())
 	rhs_sval = model.maybe_cast (m_type, rhs_sval, ctxt);
 
@@ -1334,7 +1335,7 @@ region2::get_inherited_child_sval (region2 *child,
       /* Clone the parent's value, so that attempts to update it
 	 (e.g giving a specific value to an inherited "uninitialized"
 	 value) touch the child, and not the parent.  */
-      svalue2 *this_value = model.get_svalue2 (m_sval_id);
+      const svalue2 *this_value = model.get_svalue2 (m_sval_id);
       svalue2_id new_child_sval
 	= this_value->get_child_sval (this, child, model, ctxt);
       if (ctxt)
@@ -1353,7 +1354,7 @@ region2::get_inherited_child_sval (region2 *child,
    and arrays recursively.  */
 
 void
-region_model2::copy_region (region2 *dst_reg, region2 *src_reg,
+region_model2::copy_region (const region2 *dst_reg, const region2 *src_reg,
 			    region_model2_context *ctxt)
 {
   gcc_assert (dst_reg);
@@ -1361,12 +1362,12 @@ region_model2::copy_region (region2 *dst_reg, region2 *src_reg,
   if (dst_reg == src_reg)
     return;
 
-  svalue2 *sval = get_store_value (src_reg);
+  const svalue2 *sval = get_store_value (src_reg);
   set_value (dst_reg, sval, ctxt);
 
 #if 0
   /* Copy across any value for the src region2 itself.  */
-  svalue2 *sval = src_reg->get_value (*this, true, ctxt);
+  const svalue2 *sval = src_reg->get_value (*this, true, ctxt);
   set_value (dst_reg, sid, ctxt);
 
   if (dst_reg->get_kind () != src_reg->get_kind ())
@@ -1620,7 +1621,7 @@ region2::get_view (tree type, region_model2 *model) const
 
 /* region2's ctor.  */
 
-region2::region2 (unsigned id, region2 *parent, tree type)
+region2::region2 (unsigned id, const region2 *parent, tree type)
 : m_id (id), m_parent (parent), m_type (type), m_cached_offset (NULL)
 {
   gcc_assert (type == NULL_TREE || TYPE_P (type));
@@ -1871,10 +1872,10 @@ frame_region2::add_to_hash (inchash::hash &hstate) const
 }
 #endif
 
-region2 *
+const region2 *
 frame_region2::get_region_for_local (region_model2_manager *mgr,
 				     tree expr,
-				     region_model2_context */*ctxt*/)
+				     region_model2_context */*ctxt*/) const
 {
   // TODO: could also check that VAR_DECLs are locals
   gcc_assert (TREE_CODE (expr) == PARM_DECL
@@ -1882,11 +1883,15 @@ frame_region2::get_region_for_local (region_model2_manager *mgr,
 	      || TREE_CODE (expr) == SSA_NAME
 	      || TREE_CODE (expr) == RESULT_DECL);
 
-  if (region2 **slot = m_locals.get (expr))
+  /* Ideally we'd use mutable here.  */
+  // TODO: when is it available?
+  map_t &mutable_locals = const_cast <map_t &> (m_locals);
+
+  if (region2 **slot = mutable_locals.get (expr))
     return *slot;
   decl_region2 *reg
     = new decl_region2 (mgr->alloc_region_id (), this, expr);
-  m_locals.put (expr, reg);
+  mutable_locals.put (expr, reg);
   return reg;
 }
 
@@ -2136,7 +2141,7 @@ stack_region2::get_value_by_name (tree identifier,
   FOR_EACH_VEC_ELT (m_frame_regs, i, frame_reg)
     {
       frame_region2 *frame = model.get_region2<frame_region2> (*frame_reg);
-      svalue2 *sval = frame->get_value_by_name (identifier, model);
+      const svalue2 *sval = frame->get_value_by_name (identifier, model);
       if (!sid.null_p ())
 	return sid;
     }
@@ -2473,13 +2478,13 @@ root_region2::get_value_by_name (tree identifier,
 {
   if (stack_region2 *stack = get_stack_region2 (&model))
     {
-      svalue2 *sval = stack->get_value_by_name (identifier, model);
+      const svalue2 *sval = stack->get_value_by_name (identifier, model);
       if (!sid.null_p ())
 	return sid;
     }
   if (map_region2 *globals = get_globals_region2 (&model))
     {
-      svalue2 *sval = globals->get_value_by_name (identifier, model);
+      const svalue2 *sval = globals->get_value_by_name (identifier, model);
       if (!sid.null_p ())
 	return sid;
     }
@@ -2784,7 +2789,7 @@ region_model2_manager::~region_model2_manager ()
    creating the constant_svalue2 if necessary.
    The constant_svalue2 instances are reused, based on pointer equality
    of trees  */
-svalue2 *
+const svalue2 *
 region_model2_manager::get_or_create_constant_svalue2 (tree cst_expr)
 {
   gcc_assert (cst_expr);
@@ -2798,7 +2803,7 @@ region_model2_manager::get_or_create_constant_svalue2 (tree cst_expr)
   // TODO: cst equality vs tree pointer equality?
 }
 
-svalue2 *
+const svalue2 *
 region_model2_manager::get_or_create_initial_value (const region2 *reg)
 {
   if (initial_svalue2 **slot = m_initial_values_map.get (reg))
@@ -2808,12 +2813,12 @@ region_model2_manager::get_or_create_initial_value (const region2 *reg)
   return initial_sval;
 }
 
-svalue2 *
-region_model2_manager::get_ptr_svalue2 (tree ptr_type, region2 *pointee)
+const svalue2 *
+region_model2_manager::get_ptr_svalue2 (tree ptr_type, const region2 *pointee)
 {
   /* If this is a symbolic region from dereferencing a pointer, and the types
      match, then return the original pointer.  */
-  if (symbolic_region2 *sym_reg = pointee->dyn_cast_symbolic_region2 ())
+  if (const symbolic_region2 *sym_reg = pointee->dyn_cast_symbolic_region2 ())
     if (ptr_type == sym_reg->get_pointer ()->get_type ())
       return sym_reg->get_pointer ();
 
@@ -2825,9 +2830,9 @@ region_model2_manager::get_ptr_svalue2 (tree ptr_type, region2 *pointee)
   return sval;
 }
 
-svalue2 *
+const svalue2 *
 region_model2_manager::maybe_fold_unaryop (tree type, enum tree_code op,
-					   svalue2 *arg)
+					   const svalue2 *arg)
 {
   /* Constants.  */
   if (tree cst = arg->maybe_get_constant ())
@@ -2836,11 +2841,11 @@ region_model2_manager::maybe_fold_unaryop (tree type, enum tree_code op,
   return NULL;
 }
 
-svalue2 *
+const svalue2 *
 region_model2_manager::get_or_create_unaryop (tree type, enum tree_code op,
-					      svalue2 *arg)
+					      const svalue2 *arg)
 {
-  if (svalue2 *folded = maybe_fold_unaryop  (type, op, arg))
+  if (const svalue2 *folded = maybe_fold_unaryop  (type, op, arg))
     return folded;
   unaryop_svalue2::key_t key (type, op, arg);
   if (unaryop_svalue2 **slot = m_unaryop_values_map.get (key))
@@ -2850,9 +2855,9 @@ region_model2_manager::get_or_create_unaryop (tree type, enum tree_code op,
   return unaryop_sval;
 }
 
-svalue2 *
+const svalue2 *
 region_model2_manager::maybe_fold_binop (tree type, enum tree_code op,
-					 svalue2 *arg0, svalue2 *arg1)
+					 const svalue2 *arg0, const svalue2 *arg1)
 {
   tree cst0 = arg0->maybe_get_constant ();
   tree cst1 = arg1->maybe_get_constant ();
@@ -2896,11 +2901,11 @@ region_model2_manager::maybe_fold_binop (tree type, enum tree_code op,
   return NULL;
 }
 
-svalue2 *
+const svalue2 *
 region_model2_manager::get_or_create_binop (tree type, enum tree_code op,
-					    svalue2 *arg0, svalue2 *arg1)
+					    const svalue2 *arg0, const svalue2 *arg1)
 {
-  if (svalue2 *folded = maybe_fold_binop (type, op, arg0, arg1))
+  if (const svalue2 *folded = maybe_fold_binop (type, op, arg0, arg1))
     return folded;
   binop_svalue2::key_t key (type, op, arg0, arg1);
   if (binop_svalue2 **slot = m_binop_values_map.get (key))
@@ -2914,7 +2919,7 @@ region_model2_manager::get_or_create_binop (tree type, enum tree_code op,
 
 /* FIXME.  */
 
-function_region2 *
+const function_region2 *
 region_model2_manager::get_region_for_fndecl (tree fndecl,
 					      region_model2_context */*ctxt*/)
 {
@@ -2931,7 +2936,7 @@ region_model2_manager::get_region_for_fndecl (tree fndecl,
 
 /* FIXME.  */
 
-label_region2 *
+const label_region2 *
 region_model2_manager::get_region_for_label (tree label,
 					     region_model2_context *ctxt)
 {
@@ -2944,7 +2949,7 @@ region_model2_manager::get_region_for_label (tree label,
   tree fndecl = DECL_CONTEXT (label);
   gcc_assert (fndecl && TREE_CODE (fndecl) == FUNCTION_DECL);
 
-  function_region2 *func_reg = get_region_for_fndecl (fndecl, ctxt);
+  const function_region2 *func_reg = get_region_for_fndecl (fndecl, ctxt);
   label_region2 *reg
     = new label_region2 (alloc_region_id (), func_reg, label);
   m_labels_map.put (label, reg);
@@ -2953,7 +2958,7 @@ region_model2_manager::get_region_for_label (tree label,
 
 /* FIXME.  */
 
-decl_region2 *
+const decl_region2 *
 region_model2_manager::get_region_for_global (tree expr,
 					      region_model2_context */*ctxt*/)
 {
@@ -2970,8 +2975,8 @@ region_model2_manager::get_region_for_global (tree expr,
 
 /* FIXME.  */
 
-region2 *
-region_model2_manager::get_field_region (region2 *parent, tree field,
+const region2 *
+region_model2_manager::get_field_region (const region2 *parent, tree field,
 					 region_model2_context */*ctxt*/)
 {
   // FIXME: should only alloc_region_id if consolidation fails
@@ -2981,10 +2986,10 @@ region_model2_manager::get_field_region (region2 *parent, tree field,
 
 /* FIXME.  */
 
-region2 *
-region_model2_manager::get_element_region (region2 *parent,
+const region2 *
+region_model2_manager::get_element_region (const region2 *parent,
 					   tree element_type,
-					   svalue2 *index,
+					   const svalue2 *index,
 					   region_model2_context */*ctxt*/)
 {
   // FIXME: should only alloc_region_id if consolidation fails
@@ -2995,10 +3000,10 @@ region_model2_manager::get_element_region (region2 *parent,
 
 /* FIXME.  */
 
-region2 *
-region_model2_manager::get_offset_region (region2 *parent,
+const region2 *
+region_model2_manager::get_offset_region (const region2 *parent,
 					  tree type,
-					  svalue2 *byte_offset,
+					  const svalue2 *byte_offset,
 					  region_model2_context */*ctxt*/)
 {
   /* If BYTE_OFFSET is zero and the types match, return PARENT.  */
@@ -3014,8 +3019,8 @@ region_model2_manager::get_offset_region (region2 *parent,
 
 /* FIXME.  */
 
-frame_region2 *
-region_model2_manager::get_frame_region (frame_region2 *calling_frame,
+const frame_region2 *
+region_model2_manager::get_frame_region (const frame_region2 *calling_frame,
 					 function *fun)
 {
   int index = calling_frame ? calling_frame->get_index () + 1 : 0;
@@ -3028,8 +3033,8 @@ region_model2_manager::get_frame_region (frame_region2 *calling_frame,
 
 /* FIXME.  */
 
-region2 *
-region_model2_manager::get_symbolic_region (svalue2 *sval)
+const region2 *
+region_model2_manager::get_symbolic_region (const svalue2 *sval)
 {
   // FIXME: should only alloc_region_id if consolidation fails
   region2 *reg
@@ -3039,7 +3044,7 @@ region_model2_manager::get_symbolic_region (svalue2 *sval)
 
 /* FIXME.  */
 
-string_region2 *
+const string_region2 *
 region_model2_manager::get_region_for_string (tree string_cst)
 {
   gcc_assert (TREE_CODE (string_cst) == STRING_CST);
@@ -3061,7 +3066,7 @@ region_model2_manager::get_region_for_string (tree string_cst)
    since any diagnostics we might issue will have questionable
    validity.  */
 
-region2 *
+const region2 *
 region_model2_manager::
 get_region2_for_unexpected_tree_code (region_model2_context *ctxt,
 				      tree t,
@@ -3078,7 +3083,7 @@ get_region2_for_unexpected_tree_code (region_model2_context *ctxt,
 
 /* FIXME.  */
 
-region2 *
+const region2 *
 region_model2_manager::create_region_for_heap_alloc ()
 {
   // FIXME: should this be a symbolic region??
@@ -3093,8 +3098,8 @@ region_model2_manager::create_region_for_heap_alloc ()
 
 /* FIXME.  */
 
-region2 *
-region_model2_manager::create_region_for_alloca (frame_region2 *frame)
+const region2 *
+region_model2_manager::create_region_for_alloca (const frame_region2 *frame)
 {
   region2 *reg = new alloca_region2 (alloc_region_id (), frame);
   m_managed_dynamic_regions.safe_push (reg);
@@ -3137,7 +3142,7 @@ region_model2 &
 region_model2::operator= (const region_model2 &other)
 {
   unsigned i;
-  svalue2 *svalue2;
+  const svalue2 *svalue2;
   region2 *region2;
 
   /* Delete existing content.  */
@@ -3205,7 +3210,7 @@ region_model2::hash () const
   hashval_t result = 0;
   int i;
 
-  svalue2 *svalue2;
+  const svalue2 *svalue2;
   FOR_EACH_VEC_ELT (m_svalue2s, i, svalue2)
     result ^= svalue2->hash ();
 
@@ -3227,7 +3232,7 @@ region_model2::print (pretty_printer *pp) const
   int i;
 
   pp_string (pp, "svalue2s: [");
-  svalue2 *svalue2;
+  const svalue2 *svalue2;
   FOR_EACH_VEC_ELT (m_svalue2s, i, svalue2)
     {
       if (i > 0)
@@ -3253,7 +3258,7 @@ region_model2::print (pretty_printer *pp) const
 /* Print the svalue2 with id SID to PP.  */
 
 void
-region_model2::print_svalue2 (svalue2 *sval, pretty_printer *pp) const
+region_model2::print_svalue2 (const svalue2 *sval, pretty_printer *pp) const
 {
   get_svalue2 (sid)->print (*this, sid, pp);
 }
@@ -3278,7 +3283,7 @@ region_model2::dump_dot_to_pp (pretty_printer *pp) const
 
   int i;
 
-  svalue2 *svalue2;
+  const svalue2 *svalue2;
   FOR_EACH_VEC_ELT (m_svalue2s, i, svalue2)
     svalue2->dump_dot_to_pp (*this, svalue2_id::from_int (i), pp);
 
@@ -3333,7 +3338,7 @@ region_model2::dump_to_pp (pretty_printer *pp, bool summarize) const
   /* Dump stack.  */
   pp_printf (pp, "stack depth: %i", get_stack_depth ());
   pp_newline (pp);
-  for (frame_region2 *iter_frame = m_current_frame; iter_frame;
+  for (const frame_region2 *iter_frame = m_current_frame; iter_frame;
        iter_frame = iter_frame->get_calling_frame ())
     {
       pp_printf (pp, "  frame (index %i): ", iter_frame->get_index ());
@@ -3356,7 +3361,7 @@ region_model2::dump_to_pp (pretty_printer *pp, bool summarize) const
       if (iter != m_store_map.begin ())
 	pp_string (pp, ", ");
       region2 *reg = (*iter).first;
-      svalue2 *sval = (*iter).second;
+      const svalue2 *sval = (*iter).second;
       reg->dump_to_pp (pp, summarize);
       pp_string (pp, ": ");
       sval->dump_to_pp (pp, summarize);
@@ -3436,11 +3441,11 @@ region_model2::dump_to_pp (pretty_printer *pp, bool summarize) const
   pp_string (pp, "svalue2s:");
   pp_newline (pp);
   int i;
-  svalue2 *svalue2;
+  const svalue2 *svalue2;
   FOR_EACH_VEC_ELT (m_svalue2s, i, svalue2)
     {
       pp_string (pp, "  ");
-      svalue2 *sval = svalue2_id::from_int (i);
+      const svalue2 *sval = svalue2_id::from_int (i);
       print_svalue2 (sid, pp);
       pp_newline (pp);
     }
@@ -3531,17 +3536,18 @@ region_model2::dump_summary_of_rep_path_vars (pretty_printer *pp,
       region2 *child_region2 = get_region2 (child_reg);
       if (!child_region2)
 	continue;
-      svalue2 *sval = child_region2->get_value_direct ();
+      const svalue2 *sval = child_region2->get_value_direct ();
       if (sid.null_p ())
 	continue;
-      svalue2 *sval = get_svalue2 (sid);
+      const svalue2 *sval = get_svalue2 (sid);
       switch (sval->get_kind ())
 	{
 	default:
 	  gcc_unreachable ();
 	case SK_REGION2:
 	  {
-	    region_svalue2 *region2_sval = as_a <region_svalue2 *> (sval);
+	    const region_svalue2 *region2_sval
+	      = as_a <const region_svalue2 *> (sval);
 	    region2_id pointee_reg = region2_sval->get_pointee ();
 	    gcc_assert (!pointee_reg.null_p ());
 	    tree pointee = get_representative_path_var (pointee_reg).m_tree;
@@ -3566,7 +3572,8 @@ region_model2::dump_summary_of_rep_path_vars (pretty_printer *pp,
 	  break;
 	case SK_POISONED:
 	  {
-	    poisoned_svalue2 *poisoned_sval = as_a <poisoned_svalue2 *> (sval);
+	    const poisoned_svalue2 *poisoned_sval
+	      = as_a <const poisoned_svalue2 *> (sval);
 	    enum poison_kind pkind = poisoned_sval->get_poison_kind ();
 	    if (pkind == POISON_KIND_UNINIT)
 	      uninit_trees.safe_push (pv->m_tree);
@@ -3618,7 +3625,7 @@ region_model2::validate () const
   if (stack_region2)
     {
       svalue2_id stack_value_sval = stack_region2->get_value_direct ();
-      svalue2 *stack_value = get_svalue2 (stack_value_sval);
+      const svalue2 *stack_value = get_svalue2 (stack_value_sval);
       gcc_assert (stack_value->get_kind () == SK_POISONED);
       poisoned_svalue2 *subclass = stack_value->dyn_cast_poisoned_svalue2 ();
       gcc_assert (subclass);
@@ -3679,7 +3686,7 @@ region_model2::on_gassign (const supernode */*snode*/,
   tree lhs = gimple_assign_lhs (assign);
   tree rhs1 = gimple_assign_rhs1 (assign);
 
-  region2 *lhs_reg = get_lvalue (lhs, ctxt);
+  const region2 *lhs_reg = get_lvalue (lhs, ctxt);
 
   enum tree_code op = gimple_assign_rhs_code (assign);
   switch (op)
@@ -3722,10 +3729,10 @@ region_model2::on_gassign (const supernode */*snode*/,
 	tree ptr = rhs1;
 	tree offset = gimple_assign_rhs2 (assign);
 
-	svalue2 *ptr_sval = get_rvalue (ptr, ctxt);
-	svalue2 *offset_sval = get_rvalue (offset, ctxt);
+	const svalue2 *ptr_sval = get_rvalue (ptr, ctxt);
+	const svalue2 *offset_sval = get_rvalue (offset, ctxt);
 
-	svalue2 *sval_binop
+	const svalue2 *sval_binop
 	      = m_mgr->get_or_create_binop (TREE_TYPE (lhs), op,
 					    ptr_sval, offset_sval);
 	set_value (lhs_reg, sval_binop, ctxt);
@@ -3734,7 +3741,7 @@ region_model2::on_gassign (const supernode */*snode*/,
 	  = get_or_create_pointer_plus_expr (TREE_TYPE (TREE_TYPE (ptr)),
 					     ptr_sval, offset_sval,
 					     ctxt);
-	svalue2 *element_ptr_sval
+	const svalue2 *element_ptr_sval
 	  = get_or_create_ptr_svalue2 (TREE_TYPE (ptr), element_reg);
 	set_value (lhs_reg, element_ptr_sval, ctxt);
 #endif
@@ -3767,7 +3774,7 @@ region_model2::on_gassign (const supernode */*snode*/,
     case VAR_DECL: /* LHS = VAR; */
     case PARM_DECL:/* LHS = VAR; */
       {
-	svalue2 *rhs_sval = get_rvalue (rhs1, ctxt);
+	const svalue2 *rhs_sval = get_rvalue (rhs1, ctxt);
 	set_value (lhs_reg, rhs_sval, ctxt);
       }
       break;
@@ -3777,8 +3784,8 @@ region_model2::on_gassign (const supernode */*snode*/,
     case FLOAT_EXPR:
     case NOP_EXPR:
       {
-	svalue2 *rhs_sval = get_rvalue (rhs1, ctxt);
-	svalue2 *sval_unaryop
+	const svalue2 *rhs_sval = get_rvalue (rhs1, ctxt);
+	const svalue2 *sval_unaryop
 	  = m_mgr->get_or_create_unaryop (TREE_TYPE (lhs), op, rhs_sval);
 	set_value (lhs_reg, sval_unaryop, ctxt);
       }
@@ -3794,8 +3801,8 @@ region_model2::on_gassign (const supernode */*snode*/,
 	tree rhs2 = gimple_assign_rhs2 (assign);
 
 	// TODO: constraints between svalue2s
-	svalue2 *rhs1_sval = get_rvalue (rhs1, ctxt);
-	svalue2 *rhs2_sval = get_rvalue (rhs2, ctxt);
+	const svalue2 *rhs1_sval = get_rvalue (rhs1, ctxt);
+	const svalue2 *rhs2_sval = get_rvalue (rhs2, ctxt);
 
 	tristate t = eval_condition (rhs1_sval, op, rhs2_sval);
 	if (t.is_known ())
@@ -3808,7 +3815,7 @@ region_model2::on_gassign (const supernode */*snode*/,
 	else
 	  {
 	    // TODO: symbolic value for binop
-	    svalue2 *sval_binop
+	    const svalue2 *sval_binop
 	      = m_mgr->get_or_create_binop (TREE_TYPE (lhs), op,
 					    rhs1_sval, rhs2_sval);
 	    set_value (lhs_reg, sval_binop, ctxt);
@@ -3820,8 +3827,8 @@ region_model2::on_gassign (const supernode */*snode*/,
     case BIT_NOT_EXPR:
       {
 	/* Unary ops.  */
-	svalue2 *rhs1_sval = get_rvalue (rhs1, ctxt);
-	svalue2 *sval_unaryop
+	const svalue2 *rhs1_sval = get_rvalue (rhs1, ctxt);
+	const svalue2 *sval_unaryop
 	  = m_mgr->get_or_create_unaryop (TREE_TYPE (lhs), op,
 					rhs1_sval);
 	set_value (lhs_reg, sval_unaryop, ctxt);
@@ -3844,10 +3851,10 @@ region_model2::on_gassign (const supernode */*snode*/,
 	/* Binary ops.  */
 	tree rhs2 = gimple_assign_rhs2 (assign);
 
-	svalue2 *rhs1_sval = get_rvalue (rhs1, ctxt);
-	svalue2 *rhs2_sval = get_rvalue (rhs2, ctxt);
+	const svalue2 *rhs1_sval = get_rvalue (rhs1, ctxt);
+	const svalue2 *rhs2_sval = get_rvalue (rhs2, ctxt);
 
-	svalue2 *sval_binop
+	const svalue2 *sval_binop
 	  = m_mgr->get_or_create_binop (TREE_TYPE (lhs), op,
 					rhs1_sval, rhs2_sval);
 	set_value (lhs_reg, sval_binop, ctxt);
@@ -3906,11 +3913,11 @@ region_model2::on_gcall (const supernode *snode,
       if (is_named_call_p (callee_fndecl, "malloc", call, 1))
 	{
 	  tree size_arg = gimple_call_arg (call, 0);
-	  svalue2 *size_sval = get_rvalue (size_arg, ctxt);
+	  const svalue2 *size_sval = get_rvalue (size_arg, ctxt);
 	  region2 *new_reg = create_region_for_heap_alloc (size_sval);
 	  if (lhs_reg)
 	    {
-	      svalue2 *ptr_sval = m_mgr->get_ptr_svalue2 (lhs_type, new_reg);
+	      const svalue2 *ptr_sval = m_mgr->get_ptr_svalue2 (lhs_type, new_reg);
 	      set_value (lhs_reg, ptr_sval, ctxt);
 	    }
 	  else
@@ -3922,11 +3929,11 @@ region_model2::on_gcall (const supernode *snode,
       else if (is_named_call_p (callee_fndecl, "__builtin_alloca", call, 1))
 	{
 	  tree size_arg = gimple_call_arg (call, 0);
-	  svalue2 *size_sval = get_rvalue (size_arg, ctxt);
+	  const svalue2 *size_sval = get_rvalue (size_arg, ctxt);
 	  region2 *new_reg = create_region_for_alloca (size_sval);
 	  if (lhs_reg)
 	    {
-	      svalue2 *ptr_sval = m_mgr->get_ptr_svalue2 (lhs_type, new_reg);
+	      const svalue2 *ptr_sval = m_mgr->get_ptr_svalue2 (lhs_type, new_reg);
 	      set_value (lhs_reg, ptr_sval, ctxt);
 	    }
 	  return true;
@@ -3934,7 +3941,7 @@ region_model2::on_gcall (const supernode *snode,
       else if (is_named_call_p (callee_fndecl, "strlen", call, 1))
 	{
 	  tree arg = gimple_call_arg (call, 0);
-	  svalue2 *arg_sval = get_rvalue (arg, ctxt);
+	  const svalue2 *arg_sval = get_rvalue (arg, ctxt);
 	  region2 *buf_reg = deref_rvalue (arg_sval, ctxt);
 	  if (string_region2 *str_reg = buf_reg->dyn_cast_string_region2 ())
 	    {
@@ -3943,7 +3950,7 @@ region_model2::on_gcall (const supernode *snode,
 	      int sizeof_cst = TREE_STRING_LENGTH (str_cst);
 	      int strlen_cst = sizeof_cst - 1;
 	      tree t_cst = build_int_cst (lhs_type, strlen_cst);
-	      svalue2 *result_sval
+	      const svalue2 *result_sval
 		= m_mgr->get_or_create_constant_svalue2 (t_cst);
 	      set_value (lhs_reg, result_sval, ctxt);
 	      return true;
@@ -3980,7 +3987,7 @@ region_model2::on_gcall (const supernode *snode,
 bool
 region_model2::on_call_pre (const gcall *call, region_model2_context *ctxt)
 {
-  region2 *lhs_reg;
+  const region2 *lhs_reg;
   tree lhs_type = NULL_TREE;
   if (tree lhs = gimple_call_lhs (call))
     {
@@ -4002,7 +4009,7 @@ region_model2::on_call_pre (const gcall *call, region_model2_context *ctxt)
   if (tree callee_fndecl = get_fndecl_for_call (call, ctxt))
     {
       /* Get any left-hand side for the destination of the result.  */
-      region2 *lhs_reg = NULL;
+      const region2 *lhs_reg = NULL;
       tree lhs_type = NULL_TREE;
       if (tree lhs = gimple_call_lhs (call))
 	{
@@ -4013,11 +4020,11 @@ region_model2::on_call_pre (const gcall *call, region_model2_context *ctxt)
       if (is_named_call_p (callee_fndecl, "malloc", call, 1))
 	{
 	  tree size_arg = gimple_call_arg (call, 0);
-	  svalue2 *size_sval = get_rvalue (size_arg, ctxt);
-	  region2 *new_reg = create_region_for_heap_alloc (size_sval);
+	  const svalue2 *size_sval = get_rvalue (size_arg, ctxt);
+	  const region2 *new_reg = create_region_for_heap_alloc (size_sval);
 	  if (lhs_reg)
 	    {
-	      svalue2 *ptr_sval = m_mgr->get_ptr_svalue2 (lhs_type, new_reg);
+	      const svalue2 *ptr_sval = m_mgr->get_ptr_svalue2 (lhs_type, new_reg);
 	      set_value (lhs_reg, ptr_sval, ctxt);
 	    }
 	  else
@@ -4029,11 +4036,11 @@ region_model2::on_call_pre (const gcall *call, region_model2_context *ctxt)
       else if (is_named_call_p (callee_fndecl, "__builtin_alloca", call, 1))
 	{
 	  tree size_arg = gimple_call_arg (call, 0);
-	  svalue2 *size_sval = get_rvalue (size_arg, ctxt);
-	  region2 *new_reg = create_region_for_alloca (size_sval);
+	  const svalue2 *size_sval = get_rvalue (size_arg, ctxt);
+	  const region2 *new_reg = create_region_for_alloca (size_sval);
 	  if (lhs_reg)
 	    {
-	      svalue2 *ptr_sval = m_mgr->get_ptr_svalue2 (lhs_type, new_reg);
+	      const svalue2 *ptr_sval = m_mgr->get_ptr_svalue2 (lhs_type, new_reg);
 	      set_value (lhs_reg, ptr_sval, ctxt);
 	    }
 	  return true;
@@ -4046,7 +4053,7 @@ region_model2::on_call_pre (const gcall *call, region_model2_context *ctxt)
 	  if (lhs_reg)
 	    {
 	      tree initial_arg = gimple_call_arg (call, 0);
-	      svalue2 *sval = get_rvalue (initial_arg, ctxt);
+	      const svalue2 *sval = get_rvalue (initial_arg, ctxt);
 	      set_value (lhs_reg, sval, ctxt);
 	    }
 	  return false;
@@ -4054,16 +4061,17 @@ region_model2::on_call_pre (const gcall *call, region_model2_context *ctxt)
       else if (is_named_call_p (callee_fndecl, "strlen", call, 1))
 	{
 	  tree arg = gimple_call_arg (call, 0);
-	  svalue2 *arg_sval = get_rvalue (arg, ctxt);
-	  region2 *buf_reg = deref_rvalue (arg_sval, ctxt);
-	  if (string_region2 *str_reg = buf_reg->dyn_cast_string_region2 ())
+	  const svalue2 *arg_sval = get_rvalue (arg, ctxt);
+	  const region2 *buf_reg = deref_rvalue (arg_sval, ctxt);
+	  if (const string_region2 *str_reg
+		= buf_reg->dyn_cast_string_region2 ())
 	    {
 	      tree str_cst = str_reg->get_string_cst ();
 	      /* TREE_STRING_LENGTH is sizeof, not strlen.  */
 	      int sizeof_cst = TREE_STRING_LENGTH (str_cst);
 	      int strlen_cst = sizeof_cst - 1;
 	      tree t_cst = build_int_cst (lhs_type, strlen_cst);
-	      svalue2 *result_sval
+	      const svalue2 *result_sval
 		= m_mgr->get_or_create_constant_svalue2 (t_cst);
 	      set_value (lhs_reg, result_sval, ctxt);
 	      return true;
@@ -4141,8 +4149,8 @@ region_model2::on_call_post (const gcall *call,
     if (is_named_call_p (callee_fndecl, "free", call, 1))
       {
 	tree ptr = gimple_call_arg (call, 0);
-	svalue2 *ptr_sval = get_rvalue (ptr, ctxt);
-	if (region_svalue2 *ptr_to_region2_sval
+	const svalue2 *ptr_sval = get_rvalue (ptr, ctxt);
+	if (region_const svalue2 *ptr_to_region2_sval
 	    = ptr_sval->dyn_cast_region_svalue2 ())
 	  {
 	    /* If the ptr points to an underlying heap region2, delete it,
@@ -4231,18 +4239,18 @@ public:
       bind_cluster->for_each_value (handle_sval_cb, this);
   }
 
-  static void handle_sval_cb (svalue2 *sval, reachable_region2s *this_ptr)
+  static void handle_sval_cb (const svalue2 *sval, reachable_region2s *this_ptr)
   {
     this_ptr->handle_sval (sval);
   }
 
   /* If SVAL is a pointer, add the pointee.  */
 
-  void handle_sval (svalue2 *sval)
+  void handle_sval (const svalue2 *sval)
   {
-    if (region_svalue2 *ptr = sval->dyn_cast_region_svalue2 ())
+    if (const region_svalue2 *ptr = sval->dyn_cast_region_svalue2 ())
       {
-	region2 *pointee = ptr->get_pointee ();
+	const region2 *pointee = ptr->get_pointee ();
 	/* Use const-ness of pointer type to affect mutability.  */
 	bool ptr_is_mutable = true;
 	if (ptr->get_type ()
@@ -4346,10 +4354,11 @@ region_model2::handle_unrecognized_call (const gcall *call,
 	  }
 
 	tree parm = gimple_call_arg (call, arg_idx);
-	svalue2 *parm_sval = get_rvalue (parm, ctxt);
-	if (region_svalue2 *parm_ptr = parm_sval->dyn_cast_region_svalue2 ())
+	const svalue2 *parm_sval = get_rvalue (parm, ctxt);
+	if (const region_svalue2 *parm_ptr
+	      = parm_sval->dyn_cast_region_svalue2 ())
 	  {
-	    region2 *pointee_reg = parm_ptr->get_pointee ();
+	    const region2 *pointee_reg = parm_ptr->get_pointee ();
 	    bool is_mutable = true;
 	    if (param_type
 		&& TREE_CODE (param_type) == POINTER_TYPE
